import gov.lbl.netlogger.LogMessage;
import java.util.UUID;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory; 

/**
 * Example use of NetLogger.
 */
public class NetLoggerExample {

    private String guid;
    private Log log;
    private static int COUNT = 2;
    
    /**
     * Constructor
     */
    public NetLoggerExample() {
        this.guid = UUID.randomUUID().toString();
        this.log = LogFactory.getLog(NetLoggerExample.class);
    }
     
     /**
     * Make a short example log without log4j.
     */
    public void nolog4j() {
        LogMessage m;
        for (int i = 0; i < COUNT; i++) {
            m = new LogMessage("nolog4j.start").add("guid",guid).add("count",i);
            print(m);                                
            m = new LogMessage("nolog4j.end").add("guid",guid).add("count",i);
            print(m);
        }
    }

    /**
     * Make a short example log with log4j.
     */
    public void withlog4j() {
       LogMessage m;        
       for (int i = 0; i < COUNT; i++) {
            m = new LogMessage("log4j.start").add("guid",guid).add("count",i);
            this.log.info(m);                                
            m = new LogMessage("log4j.end").add("guid",guid).add("count",i);
            this.log.info(m);                                
        }
    }

    /**
     * Program entry point.
     * 
     * @param argv
     */
    public static void main(String[] argv) {
        NetLoggerExample ex = new NetLoggerExample();
        ex.nolog4j();
        ex.withlog4j();
    }

   /** 
    * Helper function to print to console. 
    */
    private static void print(LogMessage m) {
        System.out.println(m.toString());
    }
    
}
